module Main where
import Complex
import Numeric
import IO

{- код проверен для версии: 
$ ghc --version
The Glorious Glasgow Haskell Compilation System, version 7.6.3
-}

type Point = Complex Double       -- синоним координатной точки

get_coord :: String -> Point      -- декодирование строки ввода в координаты x % y
get_coord str =
   f( words str )
   where
      f :: [String] -> Point
      f lst = ( ( read( lst !! 0 ) :: Double ) :+ ( read( lst !! 1 ) :: Double ) )

try_to_input :: IO String         -- ввод строки с ожиданием ^D
try_to_input = do
   line <- hGetLine stdin `catch` (\e -> if IO.isEOFError e then return [] else ioError e)
   return line 

get_shape :: [Point] -> IO [Point]
get_shape shape = do              -- рекурсивный ввод списка вершин
   let pos = length( shape ) + 1
   putStr( "вершина № " ++ show( pos ) ++ " : " )
   hFlush stdout
   line <- try_to_input
   if length( line ) == 0 then return shape else get_shape( get_coord( line ) : shape )

{-
forma2 :: Double -> Double
forma2 in = 
   where rest = in         
-}

showP = \p -> "[" ++ ( show( realPart( p ) ) ) ++ "," ++ ( show( imagPart( p ) ) ) ++ "] "

show_shape :: [Point] -> String
show_shape (x:xs) =
   if length xs == 0 then showP x else ( showP x ) ++ show_shape( xs ) 

perimeter :: [Point] -> Double
perimeter shape = 
   summa shape 0.0
   where distance = \ p1 p2 -> magnitude( p1 - p2 )
         summa :: [Point] -> Double -> Double
         summa (y:ys) perim       -- локальная функция накопления длин сторон
            | length( ys ) == 0 = ( distance y $ head shape ) + perim
            | otherwise = ( distance y $ head ys ) + summa ys perim 

square :: [Point] -> Double
square (y:ys) = 
   summa y ys 0.0
   where summa :: Point -> [Point] -> Double -> Double
         summa top shape squa     -- локальная функция накопления площади
            | length( tail shape ) == 0 = squa 
            | otherwise = ( triang top shape ) + summa top ( tail shape ) squa 
         triang :: Point -> [Point] -> Double
         triang top (z:zs) =      -- локальная функция площадь треугольника
            ( magnitude side1 ) * ( magnitude side2 ) *
            ( abs $ sin( phase side1 - phase side2 ) ) * 0.5
            where side1 = z - top
                  side2 = z - head zs

next_shape :: IO ()               -- цикл рассчёта
next_shape = do
   putStrLn( "координаты вершин в формате: X Y" )
   shape <- get_shape []
   putStrLn $ "\rвершин " ++ show( length shape ) ++ " : " ++ show_shape shape
   putStrLn( "периметр = " ++ show( perimeter shape ) )
   putStrLn( "площадь = " ++ show( square shape ) ) 
   putStrLn $ "---------------------------------" 
   next_shape

main :: IO ()
main = do next_shape              -- запуск цикла программы
